// sssDlg.cpp : implementation file
//

#include "stdafx.h"
#include "sss.h"
#include "sssDlg.h"
#include <new>

/////////////////////////////////////////////////////////////////////////////
// CSssDlg dialog

CSssDlg::CSssDlg(CWnd* pParent /*=NULL*/)
: CDialog(CSssDlg::IDD, pParent)
{
    //{{AFX_DATA_INIT(CSssDlg)
    //}}AFX_DATA_INIT
    // Note that LoadIcon does not require a subsequent DestroyIcon in Win32
    m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSssDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CSssDlg)
    //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSssDlg, CDialog)
//{{AFX_MSG_MAP(CSssDlg)
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSssDlg message handlers

BOOL CSssDlg::OnInitDialog() 
{
    CDialog::OnInitDialog();
    
    // TODO: Add extra initialization here
    
    return TRUE;  // return TRUE unless you set the focus to a control
    // EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CSssDlg::PreTranslateMessage(MSG* pMsg) 
{
    if(pMsg->message == WM_KEYDOWN)
    {
        CWnd* pWnd = CWnd::FromHandle(pMsg->hwnd);
        CString str;
        
        if(isalnum(pMsg->wParam))
        {
            switch(pWnd->GetDlgCtrlID())
            {
            case IDC_EDIT1:
            case IDC_EDIT2:
            case IDC_EDIT3:
            case IDC_EDIT4:
            case IDC_EDIT5:
                GetDlgItemText(pWnd->GetDlgCtrlID(), str);
                if(str.GetLength() == 5)
                {
                    CEdit* pEdit = (CEdit*)pWnd;
                    int s, e;
                    
                    pEdit->GetSel(s, e);
                    if(s != e)
                        return CDialog::PreTranslateMessage(pMsg);
                    
                    if(pWnd->GetDlgCtrlID() != IDC_EDIT5)
                    {
                        GetDlgItem(pWnd->GetDlgCtrlID()+1)->SetFocus();
                        ((CEdit*)GetDlgItem(pWnd->GetDlgCtrlID()+1))->SetSel(0, -1);
                    }
                    
                    if(pWnd->GetDlgCtrlID() != IDC_EDIT5)
                        GetDlgItem(pWnd->GetDlgCtrlID()+1)->PostMessage(WM_KEYDOWN, pMsg->wParam, pMsg->lParam);
                    
                    return TRUE;
                }
                break;
            }
        }
        else if(pMsg->wParam == VK_BACK)
        {
            switch(pWnd->GetDlgCtrlID())
            {
            case IDC_EDIT1:
            case IDC_EDIT2:
            case IDC_EDIT3:
            case IDC_EDIT4:
            case IDC_EDIT5:
                GetDlgItemText(pWnd->GetDlgCtrlID(), str);
                if(str.GetLength() == 0)
                {
                    if(pWnd->GetDlgCtrlID() != IDC_EDIT1)
                        GetDlgItem(pWnd->GetDlgCtrlID()-1)->SetFocus();
                    return TRUE;
                }
                break;
            }
        }
        else
        {
            switch(pMsg->wParam)
            {
            case VK_HOME:
            case VK_END:
            case VK_UP:
            case VK_DOWN:
            case VK_LEFT:
            case VK_RIGHT:
            case VK_TAB:
                break;
            default:
                return TRUE;
            }
        }
    }
    
    return CDialog::PreTranslateMessage(pMsg);
}
